#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "traqueboule.h"
#include "argumentParser.h"


// Utilis pour essayer diffrents types de rendu
// Utilis via le paramtre "-t" en ligne de commande
// LASTTYPE N'EST UTILISE QUE POUR CONNAITRE LA FIN DE LA LISTE
enum { TEX=0
	, LASTTYPE
};
unsigned int type = TEX;

unsigned int W_fen = 800;  // largeur fenetre
unsigned int H_fen = 800;  // hauteur fenetre


#include "loadppm.h"
PPMImage *image1 = NULL;
PPMImage *image2 = NULL;

char *filename1 = "brick.ppm";
char *filename2 = "damier.ppm";

// Dfini les bases de coordonnes de textures
float minx = 0.25;
float maxx = 0.75;


// Dfini le tyep de mlange des textures 
int e = 3;
int m = 0;

// Nombre de textures charges
int NTEX = 2;
// Tableau d'indices des textures opengl
static GLuint texName[2];

/////////////////////////
/////////////////////////



void dessinerFaceTex( )
{
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, texName[1]);
    
    // GL_QUADS == desinne des quadrilatres
    glBegin(GL_QUADS);
    glColor3f(0.0, 0.0, 1.0 ); glTexCoord2f(minx, 0.0); glVertex3f(1.0, 1.0, 0.0);
    glColor3f(0.0, 0.0, 1.0 ); glTexCoord2f(minx, 1.0); glVertex3f(-1.0, 1.0, 0.0);
    glColor3f(0.0, 0.0, 1.0 ); glTexCoord2f(maxx, 1.0); glVertex3f(-1.0, -1.0, 0.0);
    glColor3f(0.0, 0.0, 1.0 ); glTexCoord2f(maxx, 0.0); glVertex3f(1.0, -1.0, 0.0);
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
}



/**
 * Appel des diffrentes fonctions de dessin
*/
void dessiner( )
{
	switch( type )
	{
	case TEX:
		dessinerFaceTex( );
		break;
	default:
		dessinerFaceTex( );
		break;
	}
}






/**
 * Initiliasation et suppression
 */

void initDonnees()
{
	// Charge la texture en mmoire  partir de l'image ppm
	image1 = new PPMImage( filename1 );
	image2 = new PPMImage( filename2 );
	
   // Alloue NTEX textures et stock leurs identificateurs dans "texName"
   glGenTextures(NTEX, texName);

   // Explique que l'on charge la texture "texName[i]" comme la texture 2D courante
   glBindTexture(GL_TEXTURE_2D, texName[0]);
    
    // Maintenant charge l'image
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, image1->sizeX, image1->sizeY,
		  GL_RGB, GL_UNSIGNED_BYTE, image1->data);

		  
   // Explique que l'on charge la texture "texName[i]" comme la texture 2D courante
   glBindTexture(GL_TEXTURE_2D, texName[1]);
    
    // Maintenant charge l'image
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, image2->sizeX, image2->sizeY,
		  GL_RGB, GL_UNSIGNED_BYTE, image2->data);
    
}



void initGLTextures()
{
    // Que faire lorsque s ou t ne sont pas dans le domain
    // GL_CLAMP ou GL_REPEAT
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );
    
    // Que faire lorsque l'on se rapproche plus de la texture que la taille de la texture
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
    
    // inversement
    int min;
    switch( m )
    {
    	case 0: min = GL_NEAREST; break;
	case 1: min = GL_LINEAR; break;
	case 2: min = GL_NEAREST_MIPMAP_NEAREST; break;
	case 3: min = GL_LINEAR_MIPMAP_NEAREST; break;
	case 4: min = GL_NEAREST_MIPMAP_LINEAR; break;
	case 5: min = GL_LINEAR_MIPMAP_LINEAR; break;
    }
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, min );
    

    int envp;
    switch( e )
    {
    	case 0: envp = GL_MODULATE; break;
	case 1: envp = GL_DECAL; break;
	case 2: envp = GL_BLEND; break;
	case 3: envp = GL_REPLACE; break;
    }
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, envp);
}

void finDonnees()
{
}



void initLights( )
{
    // Active la gestion de la lumire
    glEnable( GL_LIGHTING );
    // Active la premire lumire
    glEnable( GL_LIGHT0 );
    // Pour plus tard : glColor3f modifie le diffus du matriaux
    glEnable(GL_COLOR_MATERIAL);


    // Dfini l'clairage de la premire lampe
    float LightPos0[4] = {0,0,0,1};     // Position
    float LightDiff0[4] = {1,1,1,1};    // Couleur diffuse
    //float LightDiff0[4] = {1,0,1,1};  // Couleur diffuse (2)
    float LightSpec0[4] = {1,1,1,1};    // Couleur spculaire

    // "glLightfv" :  la fin "fv" signifie "float" et "pointeur"
    // c'est--dire que le dernier paramtre sera un tableau de 4 floats
    glLightfv(GL_LIGHT0, GL_POSITION, LightPos0);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiff0);
    glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpec0);
}






void display(void);
void reshape(int w, int h);
void keyboard(unsigned char key, int x, int y);

/**
 * Programme principal
 */
 
int main(int argc, char** argv)
{
	
    animal::parse("Camra. Voici la liste des options: ")
    .option(&W_fen,'L',"Largeur","largeur de la fentre en pixels")
    .option(&H_fen,'H',"Hauteur","hauteur de la fentre en pixels")
    .option(&type,'t',"type","type de rendu")
    (argc,argv);

    
    glutInit(&argc, argv);

    // couches du framebuffer utilisees par l'application
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

    // position et taille de la fenetre
    glutInitWindowPosition(200, 100);
    glutInitWindowSize(W_fen,H_fen);
    glutCreateWindow(argv[0]);

    

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(0,0,-4);
    tbInitTransform();     // initialisation du point de vue
    
    //initLights();
    initDonnees( ); 
    
    // cablage des callback
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(display);
    glutMouseFunc(tbMouseFunc);    // traqueboule utilise la souris
    glutMotionFunc(tbMotionFunc);  // traqueboule utilise la souris
    glutIdleFunc( display );

    // lancement de la boucle principale
    glutMainLoop();
    
    finDonnees();
    
    return 0;  // instruction jamais excute
}


// Actions d'affichage
// Ne pas changer
void display(void)
{
    initGLTextures();
    
    // Details sur le mode de trac
    glEnable( GL_DEPTH_TEST );            // effectuer le test de profondeur
    //glEnable(GL_CULL_FACE);
    //glCullFace(GL_BACK);
    
    glPolygonMode(GL_FRONT,GL_FILL);
    glPolygonMode(GL_BACK,GL_LINE);

    
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT );
    
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    
    tbVisuTransform();
    
    
    dessiner( );
    
    glutSwapBuffers();
    
}



// pour changement de taille ou desiconification
void reshape(int w, int h)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    
    gluPerspective (50, (float)w/h, 1, 100);
    glMatrixMode(GL_MODELVIEW);
    glutPostRedisplay();
}


// On utilise ce parametre comme modificateur des variables
// Il peut tre changer avec '+' et '-'
float ddata = 0.5;

// prise en compte du clavier
void keyboard(unsigned char key, int mousex, int mousey)
{
    //printf("key %d pressed at %d,%d\n",key,mousex,mousey);
    //fflush(stdout);
    switch (key)
    {
    case 27:     // touche ESC
        exit(0);
	
    case 't':
    	type = (type+1)%(LASTTYPE);
	break;

    case 'x':
        minx -= 0.01;
	break;
    case 'X':
        minx += 0.01;
	break;
    case 'c':
       maxx -= 0.01;
	break;
    case 'C':
        maxx += 0.01;
	break;
    case 'e':
        e = (e+1)%4;
	fprintf( stderr, "e = %d\n", e );
	break;
    case 'm':
    	m = (m+1)%6;
	fprintf( stderr, "m = %d\n", m );
	break;
	
    }
 
}

